//
//  detectionContours.java
//  detectionContours
//
//  Created by Thomas Jannaud on 22/12/09.
//  Copyright (c) 2009 Jannaud's Technical Company. All rights reserved.
//

import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.awt.Toolkit;
import javax.swing.event.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.filechooser.FileFilter;
import java.io.File;


public class detectionContours extends JFrame implements ActionListener, ChangeListener, ItemListener {
	public cadrePhoto photo;
	protected Action openAction, clearAction, stopSelectAction;
	static final JMenuBar mainMenuBar = new JMenuBar();	
	private ButtonGroup groupeBtoW = new ButtonGroup();
	private ButtonGroup groupeDetec = new ButtonGroup();
	private JCheckBox checkContourInRed = new JCheckBox("Contour in red", false);
	private JCheckBox checkImageInColors = new JCheckBox("Image in colors", false);
	private JLabel lblGreyLevel = new JLabel(""), lblThickness = new JLabel(" thickness : 3");
	private JScrollPane pictureScrollPane;
	public JSlider slideNb = new JSlider(1, 5, 3);
	
	public detectionContours() {
		super("");
		photo = new cadrePhoto(lblGreyLevel);
		setTitle("Contour Detection");
		this.getContentPane().setLayout(null);
		
		JButton boutonDetect = new JButton("Detect contour");
		JButton boutonStop = new JButton("Stop");
		createActions();
		addMenus();
		
		slideNb.setMinorTickSpacing(1);
		slideNb.setPaintTicks(true);
		
		JRadioButton radioGradientX = new JRadioButton("Gradient X", false);
		JRadioButton radioGradientY = new JRadioButton("Gradient Y", false);
		JRadioButton radioGradientXY = new JRadioButton("Gradient X+Y", false);
		JRadioButton radioSobol = new JRadioButton("Sobel", false);
		JRadioButton radioLaplacien = new JRadioButton("Laplacien", false);
		JRadioButton radioCanny = new JRadioButton("Canny", false);
		JRadioButton radioGrapheCut = new JRadioButton("Graphe Cut", true);
		JRadioButton radioGrapheCutValue = new JRadioButton("Graphe Cut (value stop)", false);
		JRadioButton radioGrapheCutRatio = new JRadioButton("Graphe Cut (ratio stop)", false);
		groupeDetec.add(radioGradientX);
		groupeDetec.add(radioGradientY);
		groupeDetec.add(radioGradientXY);
		groupeDetec.add(radioSobol);
		groupeDetec.add(radioLaplacien);
		groupeDetec.add(radioCanny);
		groupeDetec.add(radioGrapheCut);
		groupeDetec.add(radioGrapheCutValue);
		groupeDetec.add(radioGrapheCutRatio);
		
		slideNb.addChangeListener(this);
		checkContourInRed.addItemListener(this);
		checkImageInColors.addItemListener(this);
		boutonStop.addActionListener(this);
		boutonDetect.addActionListener(this);
		radioSobol.addActionListener(this);
		radioGradientX.addActionListener(this);
		radioGradientY.addActionListener(this);
		radioGradientXY.addActionListener(this);
		radioGrapheCut.addActionListener(this);
		radioCanny.addActionListener(this);
		radioLaplacien.addActionListener(this);
		
      pictureScrollPane = new JScrollPane(photo, ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED, ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		
		JPanel boutons = new JPanel();
		boutons.setLayout(new GridLayout(4, 2));
		boutons.add(boutonDetect);
		boutons.add(checkContourInRed);
		boutons.add(boutonStop);
		boutons.add(checkImageInColors);
		boutons.add(lblThickness);
		boutons.add(slideNb);
		boutons.add(lblGreyLevel);
		
		JPanel optionsDetec = new JPanel();
		optionsDetec.setLayout(new GridLayout(5, 2));
		optionsDetec.add(new JLabel("Contour Detection"));
		optionsDetec.add(radioGradientX);
		optionsDetec.add(radioGradientY);
		optionsDetec.add(radioGradientXY);
		optionsDetec.add(radioSobol);
		optionsDetec.add(radioLaplacien);
		optionsDetec.add(radioCanny);
		optionsDetec.add(radioGrapheCut);
		optionsDetec.add(radioGrapheCutValue);
		optionsDetec.add(radioGrapheCutRatio);
		
		JPanel commandes = new JPanel();
		commandes.setLayout(new GridLayout(1, 2));
		commandes.add(boutons);
		commandes.add(optionsDetec);
		
		setLayout(new BorderLayout());
		add(pictureScrollPane, BorderLayout.CENTER);
		add(commandes, BorderLayout.SOUTH);
		
		setSize(510, 450);
		setVisible(true);
	}
	
	public void createActions() {
		int shortcutKeyMask = Toolkit.getDefaultToolkit().getMenuShortcutKeyMask();
		openAction = new openActionClass(this, "Open", KeyStroke.getKeyStroke(KeyEvent.VK_O, shortcutKeyMask));
		clearAction = new clearActionClass("Reload", KeyStroke.getKeyStroke(KeyEvent.VK_R, shortcutKeyMask));
		stopSelectAction = new stopSelectActionClass("Deselect", KeyStroke.getKeyStroke("ESCAPE"));
	}
	
	public void addMenus() {
		JMenu fileMenu = new JMenu("Image");
		fileMenu.add(new JMenuItem(openAction));
		fileMenu.add(new JMenuItem(clearAction));
		fileMenu.add(new JMenuItem(stopSelectAction));
		mainMenuBar.add(fileMenu);
		setJMenuBar (mainMenuBar);
	}
	
	public class openActionClass extends AbstractAction {
		JFrame fenetre;
		public openActionClass(JFrame fenetre, String text, KeyStroke shortcut) {
			super(text); 
			this.fenetre = fenetre;
			putValue(ACCELERATOR_KEY, shortcut);
		}
		public void actionPerformed(ActionEvent e) {
			JFileChooser filebox = new JFileChooser("/Users/Thomas/Documents/Programmation/Java/detectionContours/images/");
			filebox.addChoosableFileFilter(new FiltreImage());
			if(filebox.showOpenDialog(fenetre) == JFileChooser.APPROVE_OPTION)
				photo.setPicture(filebox.getSelectedFile().getPath());
			// photo.setPicture("/Users/Thomas/Documents/Programmation/Java/detectionContours/images/carre.png");
			// photo.setPicture("/Users/Thomas/Documents/Programmation/Java/detectionContours/images/rond.png");
			//	photo.setPicture("/Users/Thomas/Documents/Programmation/Java/detectionContours/images/2 ronds.png");
			// photo.setPicture("/Users/Thomas/Documents/Programmation/Java/detectionContours/images/couleurs.png");
		}
	}
	
	public class clearActionClass extends AbstractAction {
		public clearActionClass(String text, KeyStroke shortcut) {
			super(text); 
			putValue(ACCELERATOR_KEY, shortcut);
		}
		public void actionPerformed(ActionEvent e) {
			photo.reload();
		}
	}
	
	public class stopSelectActionClass extends AbstractAction {
		public stopSelectActionClass(String text, KeyStroke shortcut) {
			super(text);
			putValue(ACCELERATOR_KEY, shortcut);
		}
		public void actionPerformed(ActionEvent e) {
			photo.deselect();
		}
	}
	
	public static void main(String args[]) {
		new detectionContours();
	}
	
	public void actionPerformed(ActionEvent action) {
		String s = action.getActionCommand();
		if (s.equals("Gradient X"))
			photo.setDetectionMode(contourDetector.GRADIENT_X);			
		else if (s.equals("Gradient Y"))
			photo.setDetectionMode(contourDetector.GRADIENT_Y);			
		else if (s.equals("Gradient X+Y"))
			photo.setDetectionMode(contourDetector.GRADIENT_XY);			
		else if (s.equals("Sobel"))
			photo.setDetectionMode(contourDetector.GRADIENT_SOBEL);			
		else if (s.equals("Laplacien"))
			photo.setDetectionMode(contourDetector.LAPLACIEN);			
		else if (s.equals("Canny"))
			photo.setDetectionMode(contourDetector.GRADIENT_CANNY);			
		else if (s.equals("Graphe Cut"))
			photo.setDetectionMode(contourDetector.GRAPHE_MIN_CUT);			
		else if (s.equals("Graphe Cut (ratio stop)"))
			photo.setDetectionMode(contourDetector.GRAPHE_MIN_CUT_ARRET_RATIO);			
		else if (s.equals("Graphe Cut (value stop)"))
			photo.setDetectionMode(contourDetector.GRAPHE_MIN_CUT_ARRET_CUT);			
		else if (s.equals("Detect contour"))
			photo.detectContours(slideNb.getValue());
		else if (s.equals("Stop"))
			photo.stop();
	}
	
	public void stateChanged(ChangeEvent e) {
		if (e.getSource() == slideNb)
			lblThickness.setText(" thickness : " + slideNb.getValue());
	}
	
	public void itemStateChanged(ItemEvent e) {
		Object source = e.getItemSelectable();
		if (source == checkContourInRed) {
			if (e.getStateChange() == ItemEvent.SELECTED)
				photo.setGreyMode(cadrePhoto.RED);
			else
				photo.setGreyMode(cadrePhoto.GREY);
		}
		else if (source == checkImageInColors) {
			photo.setImageInColor(e.getStateChange() == ItemEvent.SELECTED);
		}
	}
}

class FiltreImage extends FileFilter {
	public FiltreImage(){}
	public boolean accept(File file){
		if(file.isDirectory())
			return true;
		String nomFichier = file.getName().toLowerCase();
		return nomFichier.endsWith(".jpg") || nomFichier.endsWith(".png");
	}
	public String getDescription(){
		return "Images JPEG, PNG";
	}
}